package com.loafle.overflow.module.sensor.service;

import com.loafle.overflow.module.core.annotation.WebappAPI;
import com.loafle.overflow.module.core.exception.OverflowException;
import com.loafle.overflow.module.core.model.PageParams;
import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.sensor.model.Sensor;
import com.loafle.overflow.module.sensor.model.SensorItem;
import com.loafle.overflow.module.target.model.Target;
import org.springframework.data.domain.Page;

import java.util.List;

/**
 * Created by insanity on 17. 6. 28.
 */
public interface SensorService  {
    @WebappAPI
    Sensor regist(Sensor sensor) throws OverflowException;
    @WebappAPI
    Sensor read(String id) throws OverflowException;
    @WebappAPI
    void remove(Sensor sensor) throws OverflowException;
    @WebappAPI
    Sensor start(Sensor sensor) throws OverflowException;
    @WebappAPI
    Sensor stop(Sensor sensor) throws OverflowException;
    @WebappAPI
    Sensor registSensorConfig(Sensor sensor, List<SensorItem> sensorItemList, String etcJson) throws OverflowException;
    @WebappAPI
    String generateSensorConfig(Sensor sensor) throws OverflowException;

    @WebappAPI
    Page<Sensor> readAllByDomain(Domain domain, PageParams pageParams) throws OverflowException;
    @WebappAPI
    Page<Sensor> readAllByInfra(long infraId, PageParams pageParams) throws OverflowException;
    @WebappAPI
    Page<Sensor> readAllByTarget(Target target, PageParams pageParams) throws OverflowException;
}
